Subject: [core] CoAP Security

From: Vipul Gupta <[email-masked]>
Date: Wed, 2 Jun 2010 13:42:29 -0700

On May 24, 2010, [email-masked] wrote:
 
> Regarding DTLS, we are specifying how to use it with CoAP as it is a secure transport. I agree with Michael that DTLS may very well be too much for many constrained devices, so we should make it clear that this is not the only way to do security, IPSEC e.g. is equally applicable (and probably simpler) but doesn't require any specification in the document. A security analysis ID would be a big help for the WG.....

I might be missing something here but what would make IPsec lighter weight than DTLS?

I've had experience building an SSL stack for Berkeley "mote" devices with as little as 4KB SRAM, 128KB Flash and an 8-bit processor (look for a couple of papers with "Sizzle", for Slim SSL, in their title at http://labs.oracle.com/projects/crypto/ under Research Publications). As one might expect, it is the public-key crypto operations needed for the key exchange that dominate the code size and handshake time and this would not change between DTLS/TLS and IPSec. The message format used to package long-term keys needed for session key establishment or the encrypted/authenticated application data (and that's where TLS/DTLS and IPSec differ) doesn't have much of an impact.

Another paper that may be of interest to folks here is http://labs.oracle.com/techrep/2008/abstract-173.html which discusses the energy cost of SSL on very constrained devices.

vipul

---
http://labs.oracle.com/people/mybio.php?c=509